<?php

class Controller_Office_Disciplines extends Controller_Environment_Office {

    public function before() {
        parent::before();
        $this->user->checkAccess(User::RIGHTS_DEAN | User::RIGHTS_ADMIN);
    }

    public function action_index() {
        $this->twig->set_filename(self::OFFICE . 'disciplines/index');
    }

    private function fullness($param, $semesterID = null){
        $semesterID = $semesterID ?: User::instance()->SemesterID;
        $facultyID = $this->user->Faculty->ID;
        $disciplines = Model_Disciplines::getWithFullness($param, $semesterID, $facultyID);
        $teachers = [];
        foreach ($disciplines as $discipline) {
            $teachers[$discipline->ID] = Model_Teacher::with($discipline->AuthorID);
        }

        $this->twig->set_filename(self::OFFICE . 'disciplines/fullness')
            ->set([
                'Disciplines' => $disciplines,
                'Teachers'    => $teachers
            ]);
    }

    public function action_fullness_noukd() {
        $this->fullness('noukd');
        /*$semesterID = Model_System::$SemesterID;
        $facultyID = $this->user->Faculty->ID;
        $disciplines = Model_Disciplines::getWithFullness('noukd', $semesterID, $facultyID);
        $teachers = [];
        foreach ($disciplines as $discipline) {
            $teachers[$discipline->ID] = Model_Teacher::with($discipline->AuthorID);
        }

        $this->twig->set_filename(self::OFFICE . 'disciplines/fullness')
            ->set([
                'Disciplines' => $disciplines, //Model_Disciplines::getWithFullness('noukd', $semesterID, $facultyID),
                'Teachers'    => $teachers //Model_Teachers::ofFaculty($facultyID)->groupByUniqueKey('ID'),
            ]);*/
    }

    public function action_fullness_norate() {
        $this->fullness('norate');
        /*$semesterID = Model_System::$SemesterID;
        $facultyID = $this->user->Faculty->ID;
        $disciplines = Model_Disciplines::getWithFullness('norate', $semesterID, $facultyID);
        $teachers = [];
        foreach ($disciplines as $discipline) {
            $teachers[$discipline->ID] = Model_Teacher::with($discipline->AuthorID);
        }

        $this->twig->set_filename(self::OFFICE . 'disciplines/fullness')
            ->set([
                'Disciplines' => $disciplines, //Model_Disciplines::getWithFullness('norate', $semesterID, $facultyID),
                'Teachers'    => $teachers //Model_Teachers::ofFaculty($facultyID)->groupByUniqueKey('ID'),
            ]);*/
    }

    public function action_fullness_full() {
        $this->fullness('full');
        /*$semesterID = Model_System::$SemesterID;
        $facultyID = $this->user->Faculty->ID;
        $disciplines = Model_Disciplines::getWithFullness('full', $semesterID, $facultyID);
        $teachers = [];
        foreach ($disciplines as $discipline) {
            $teachers[$discipline->ID] = Model_Teacher::with($discipline->AuthorID);
        }

        $this->twig->set_filename(self::OFFICE . 'disciplines/fullness')
            ->set([
                'Disciplines' => $disciplines, //Model_Disciplines::getWithFullness('full', $semesterID, $facultyID),
                'Teachers'    => $teachers //Model_Teachers::ofFaculty($facultyID)->groupByUniqueKey('ID'),
            ]);*/
    }
}
